program ttwxml;

uses
  dvcrt, dvwin, dvarq, SysUtils, classes, LibXmlParser;

type
    PStatus = ^TStatus;
    PUser = ^TUser;
    PCategory = ^TCategory;
    PSettings = ^TSettings;
    PId_list = ^TId_list;
    PHash = ^THash;

    TStatuses = TList;
    TSuggestions = TList;
    TErrors = TStringList;
    TNil__classes = TList;

    TStatus = record
        created_at: string;
        id: string;
        text: string;
        source: string;
        truncated: string;
        favorited: string;
        in_reply_to_status_id: string;
        in_reply_to_user_id: string;
        in_reply_to_screen_name: string;
        retweet_count: string;
        retweeted: string;
        user: PUser;
        geo: string;
        coordinates: string;
        place: string;
        contributors: string;
        retweeted_status: Pstatus;
        possibly_sensitive: string;
    end;

    TUser = record
        id: string;
        name: string;
        screen_name: string;
        location: string;
        description: string;
        profile_image_url: string;
        profile_image_url_https: string;
        url: string;
        protected_: string;
        followers_count: string;
        profile_background_color: string;
        profile_text_color: string;
        profile_link_color: string;
        profile_sidebar_fill_color: string;
        profile_sidebar_border_color: string;
        friends_count: string;
        created_at: string;
        favourites_count: string;
        utc_offset: string;
        time_zone: string;
        profile_background_image_url: string;
        profile_background_image_url_https: string;
        profile_background_tile: string;
        profile_use_background_image: string;
        notifications: string;
        geo_enabled: string;
        verified: string;
        following: string;
        statuses_count: string;
        lang: string;
        contributors_enabled: string;
        follow_request_sent: string;
        listed_count: string;
        show_all_inline_media: string;
        default_profile: string;
        default_profile_image: string;
        is_translator: string;
        status: PStatus;
        retweeted_status: PStatus;
    end;

    TCategory = record   // suggestions
        name: string;
        slug: string;
        size: integer;
    end;

    TSettings = record
        trend__location: record
            centroid__latitude: string;
            centroid__longitude: string;
            country: string;
            country__code: string;
            id: string;
            location__id: integer;
            name: string;
            parent__id: integer;
            place__type: integer;
          end;
        geo_enabled: string;
        discoverable_by_email: string;
        sleep_time: record
            start_time: string;
            end_time: string;
            enabled: string;
        end;
        always_use_https: string;
        time_zone: record
            name: string;
            utc_offset: string;
            tzinfo_name: string;
        end;
        language: string;
        show_all_inline_media: string;
        protected_: string;
        screen_name: string;
    end;

    TId_list = record
        Tids: TStringList;
        next_cursor: integer;
        previous_cursor: integer;
    end;

    THash = record
        error: string;
        request: string;
    end;

var
    Parser: TXmlParser;

function processaStatus: PStatus; forward;

function processaUser: PUser;
var pusu: PUser;

    procedure atribui;
    var t: string;
        c: string;
    begin
        t := Parser.Curname;
        if t = 'status' then
            begin
                pusu^.status := processaStatus;
            end
        else
        if t = 'retweeted_status' then
            begin
                pusu^.retweeted_status := processaStatus;
            end
        else

        with pusu^ do
                begin
                    Parser.Scan;
                    c := Parser.CurContent;
                    if      t = 'id'                                 then id := c
                    else if t = 'name'                               then name := c
                    else if t = 'screen_name'                        then screen_name := c
                    else if t = 'location'                           then location := c
                    else if t = 'description'                        then description := c
                    else if t = 'profile_image_url'                  then profile_image_url := c
                    else if t = 'profile_image_url_https'            then profile_image_url_https := c
                    else if t = 'url'                                then url := c
                    else if t = 'protected'                          then protected_ := c
                    else if t = 'followers_count'                    then followers_count := c
                    else if t = 'profile_background_color'           then profile_background_color := c
                    else if t = 'profile_text_color'                 then profile_text_color := c
                    else if t = 'profile_link_color'                 then profile_link_color := c
                    else if t = 'profile_sidebar_fill_color'         then profile_sidebar_fill_color := c
                    else if t = 'profile_sidebar_border_color'       then profile_sidebar_border_color := c
                    else if t = 'friends_count'                      then friends_count := c
                    else if t = 'created_at'                         then created_at := c
                    else if t = 'favourites_count'                   then favourites_count := c
                    else if t = 'utc_offset'                         then utc_offset := c
                    else if t = 'time_zone'                          then time_zone := c
                    else if t = 'profile_background_image_url'       then profile_background_image_url := c
                    else if t = 'profile_background_image_url_https' then profile_background_image_url_https := c
                    else if t = 'profile_background_tile'            then profile_background_tile := c
                    else if t = 'profile_use_background_image'       then profile_use_background_image := c
                    else if t = 'notifications'                      then notifications := c
                    else if t = 'geo_enabled'                        then geo_enabled := c
                    else if t = 'verified'                           then verified := c
                    else if t = 'following'                          then following := c
                    else if t = 'statuses_count'                     then statuses_count := c
                    else if t = 'lang'                               then lang := c
                    else if t = 'contributors_enabled'               then contributors_enabled := c
                    else if t = 'follow_request_sent'                then follow_request_sent := c
                    else if t = 'listed_count'                       then listed_count := c
                    else if t = 'show_all_inline_media'              then show_all_inline_media := c
                    else if t = 'default_profile'                    then default_profile := c
                    else if t = 'default_profile_image'              then default_profile_image := c
                    else if t = 'is_translator'                      then is_translator := c
                    else writeln ('Encontrei uma coisa estranha: ', t);
                end;
    end;

begin
    new (pusu);
    result := NIL;
    while Parser.Scan DO
        begin
            if (Parser.CurPartType = ptStartTag) then
                 begin
                     atribui;
                 end
            else
            if Parser.CurPartType = ptEndTag then
                begin
                    if Parser.CurName = 'user' then
                        begin
                            result := pusu;
                            exit;
                        end;
                end
            else
                if (Parser.CurPartType <> ptEmptyTag) then
                    begin
                        writeln ('xml bichado: ', Parser.CurName,  '  Tecle enter');
                        readln;
                    end;
        end;
end;

function processaStatus: PStatus;
var pst: PStatus;

    procedure atribui;
    var t: string;
        c: string;
    begin
        t := Parser.Curname;
        if t = 'user' then
            begin
                pst^.user := processaUser;
            end
        else
        if t = 'retweeted_status' then
            begin
                pst^.retweeted_status := processaStatus;
            end
        else
            with pst^ do
                begin
                    Parser.Scan;
                    c := Parser.CurContent;

                    if      t = 'created_at'              then created_at := c
                    else if t = 'id'                      then id := c
                    else if t = 'text'                    then text := c
                    else if t = 'source'                  then source := c
                    else if t = 'truncated'               then truncated := c
                    else if t = 'favorited'               then favorited := c
                    else if t = 'in_reply_to_status_id'   then in_reply_to_status_id := c
                    else if t = 'in_reply_to_user_id'     then in_reply_to_user_id := c
                    else if t = 'in_reply_to_screen_name' then in_reply_to_screen_name := c
                    else if t = 'retweet_count'           then retweet_count := c
                    else if t = 'retweeted'               then retweeted := c
                    else if t = 'geo'                     then geo := c
                    else if t = 'coordinates'             then coordinates := c
                    else if t = 'place'                   then place := c
                    else if t = 'contributors'            then contributors := c
                    else if t = 'possibly_sensitive'      then possibly_sensitive := c
                    else writeln ('Encontrei uma coisa estranha: ', t);
                end;
    end;

begin
    new (pst);
    result := NIL;
    while Parser.Scan DO
        begin
            if (Parser.CurPartType = ptStartTag) then
                 atribui
            else
            if Parser.CurPartType = ptEndTag then
                begin
                    if (Parser.CurName = 'status') or (Parser.CurName = 'retweeted_status') then
                        begin
                            result := pst;
                            exit;
                        end;
                end
            else
                if (Parser.CurPartType <> ptEmptyTag) then
                    begin
                        writeln ('xml bichado: ', Parser.CurName,  '  Tecle enter');
                        readln;
                    end;
        end;
end;

function processaStatuses: Tstatuses;
var stats: TStatuses;
begin
    stats := Tstatuses.Create;
    result := NIL;
    while Parser.Scan DO
        begin
            if (Parser.CurPartType = ptStartTag) and (Parser.CurName = 'status') then
                 begin
                     stats.Add(processaStatus);
                 end
            else
            if (Parser.CurPartType = ptEndTag) and (Parser.CurName = 'statuses') then
                begin
                    result := stats;
                    exit;
                end
            else
                if (Parser.CurPartType <> ptEmptyTag) then
                    begin
                        writeln ('xml bichado: ', Parser.CurName,  '  Tecle enter');
                        readln;
                    end;
        end;
end;

function processaSuggestions: TSuggestions;
var
    psug: TSuggestions;
    pcat: PCategory;

    procedure atribui;
    var t: string;
        c: string;
    begin
        t := Parser.Curname;
        Parser.Scan;
        c := Parser.CurContent;
        if      t = 'name' then pcat^.name := c
        else if t = 'slug' then pcat^.slug := c
        else if t = 'size' then pcat^.size := strToInt (c)
        else writeln ('Encontrei uma coisa estranha: ', t);
    end;

begin
    psug := TSuggestions.Create;
    result := psug;
    pcat := NIL;
    while Parser.Scan DO
        begin
            if Parser.CurPartType = ptStartTag then
                 if Parser.CurName = 'category' then
                     begin
                         new (pcat);
                         pcat^.name := '';
                         pcat^.slug := '';
                         pcat^.size := 0;
                         psug.add (pcat);
                     end
                 else
                     atribui
            else
            if (Parser.CurPartType = ptEndTag) then
                begin
                    if (Parser.CurName = 'suggestions') then
                        begin
                            result := psug;
                            exit;
                        end;
                end
            else
                if (Parser.CurPartType <> ptEmptyTag) then
                    begin
                        writeln ('xml bichado: ', Parser.CurName,  '  Tecle enter');
                        readln;
                    end;
        end;
end;

function processaSettings: Psettings;
var
    pset: PSettings;

    procedure atribui;
    var t: string;
        c: string;
    begin
        t := Parser.Curname;
        if (t = 'trend-location') or (t = 'sleep_time') or (t = 'time_zone') then
           begin end
        else
        with pset^ do
            begin
                Parser.Scan;
                c := Parser.CurContent;

                if      t = 'centroid-latitude'     then trend__location.centroid__latitude := c
                else if t = 'centroid-longitude'    then trend__location.centroid__longitude := c
                else if t = 'country'               then trend__location.country := c
                else if t = 'country-code'          then trend__location.country__code := c
                else if t = 'id'                    then trend__location.id := c
                else if t = 'location-id'           then trend__location.location__id := strToInt(c)
                else if t = 'name'                  then trend__location.name := c
                else if t = 'parent-id'             then trend__location.parent__id := strToInt(c)
                else if t = 'place-type'            then trend__location.place__type := strToInt(c)
                else if t = 'geo_enabled'           then geo_enabled := c
                else if t = 'discoverable_by_email' then discoverable_by_email := c
                else if t = 'start_time'            then sleep_time.start_time := c
                else if t = 'end_time'              then sleep_time.end_time := c
                else if t = 'enabled'               then sleep_time.enabled := c
                else if t = 'always_use_https'      then always_use_https := c
                else if t = 'name'                  then time_zone.name := c
                else if t = 'utc_offset'            then time_zone.utc_offset := c
                else if t = 'tzinfo_name'           then time_zone.tzinfo_name := c
                else if t = 'language'              then language := c
                else if t = 'show_all_inline_media' then show_all_inline_media := c
                else if t = 'protected'             then protected_ := c
                else if t = 'screen_name'           then screen_name := c
                else writeln ('Encontrei uma coisa estranha: ', t);
            end;
    end;

begin
    new (pset);
    result := NIL;
    while Parser.Scan DO
        begin
            if (Parser.CurPartType = ptStartTag) then
                 begin
                     //write ('.. ', Parser.Curname);
                     atribui;
                 end
            else
            if (Parser.CurPartType = ptEndTag) and (Parser.CurName = 'settings') then
                begin
                    //writeln ('Atingi fim: ', Parser.CurName);
                    result := pset;
                    exit;
                end
            else
                if (Parser.CurPartType <> ptEmptyTag) then
                    begin
                        writeln ('xml bichado: ', Parser.CurName,  '  Tecle enter');
                        readln;
                    end;
        end;
end;

function processaErrors: TErrors;
var erros: TStringList;
    nerro: string;
begin
    erros := TStringList.Create;
    result := NIL;
    while Parser.Scan DO
        begin
            if (Parser.CurPartType = ptStartTag) and (Parser.CurName = 'error') then
                 begin
                     //...................melhorar este cdigo ........................
                     nerro := Parser.CurAttr.Value(0);
                     parser.scan;
                     erros.Add(nerro + ' ' + Parser.CurContent);
                 end
            else
            if (Parser.CurPartType = ptEndTag) and (Parser.CurName = 'errors') then
                begin
                    //writeln ('Atingi fim: ', Parser.CurName);
                    result := erros;
                    exit;
                end

            else
                if (Parser.CurPartType <> ptEmptyTag) then
                    begin
                        writeln ('xml bichado: ', Parser.CurName,  '  Tecle enter');
                        readln;
                    end;
        end;
end;

function processaId_List: PId_List;
var
    lista: PId_list;
    t: string;
begin
    lista := new(PId_list);
    lista.Tids := TstringList.create;

    result := NIL;
    while Parser.Scan DO
        begin
            if (Parser.CurPartType = ptStartTag) then
                begin
                    t := Parser.CurName;
                    Parser.Scan;
                    if t = 'id' then
                        lista.Tids.Add(Parser.CurContent)
                    else
                    if t = 'next_cursor' then
                        lista.next_cursor := strToInt(Parser.CurContent)
                    else
                    if t = 'previous_cursor' then
                        lista.previous_cursor := strToInt(Parser.CurContent)
                    else
                        writeln ('Encontrei uma coisa estranha: ', t);
                end
            else
            if (Parser.CurPartType = ptEndTag) and (Parser.CurName = 'id_list') then
                begin
                    //writeln ('Atingi fim: ', Parser.CurName);
                    result := lista;
                    exit;
                end
            else
                if (Parser.CurPartType <> ptEmptyTag) then
                    begin
                        writeln ('xml bichado: ', Parser.CurName,  '  Tecle enter');
                        readln;
                    end;
        end;

end;

function processaHash: PHash;
var phsh: PHash;

    procedure atribui;
    var t: string;
        c: string;
    begin
        t := Parser.Curname;
        with phsh^ do
                begin
                    Parser.Scan;
                    c := Parser.CurContent;
                    if      t = 'error'   then error := c
                    else if t = 'request' then request := c
                    else writeln ('Encontrei uma coisa estranha: ', t);
                end;
    end;

begin
    new (phsh);
    result := NIL;
    while Parser.Scan DO
        begin
            if (Parser.CurPartType = ptStartTag) then
                 atribui
            else
            if Parser.CurPartType = ptEndTag then
                begin
                    if (Parser.CurName = 'hash') then
                        begin
                            result := phsh;
                            exit;
                        end;
                end
            else
                if (Parser.CurPartType <> ptEmptyTag) then
                    begin
                        writeln ('xml bichado: ', Parser.CurName,  '  Tecle enter');
                        readln;
                    end;
        end;
end;

function processaNilClasses: TNil__classes;
begin
    result := NIL;
    while Parser.Scan DO
        if (Parser.CurPartType = ptEndTag) and (Parser.CurName = 'nil-classes') then
            exit;
end;

function executaParsing (pxml: pchar; var rootType: string): pointer;
begin
    Parser := TXmlParser.Create;
    Parser.Normalize := TRUE;
    Parser.SetBuffer(pxml);
    Parser.StartScan;

    result := NIL;
    Parser.Scan;
    Parser.Scan;

    rootType := Parser.CurName;
    writeln ('root=', Parser.CurName);

    if Parser.CurPartType = ptStartTag then
        if Parser.CurName = 'statuses'    then result := processaStatuses
        else
        if Parser.CurName = 'status'      then result := processaStatus
        else
        if Parser.CurName = 'user'        then result := processaUser
        else
        if Parser.CurName = 'settings'    then result := processaSettings
        else
        if Parser.CurName = 'errors'      then result := processaErrors
        else
        if Parser.CurName = 'id_list'     then result := processaId_List
        else
        if Parser.CurName = 'suggestions' then result := processaSuggestions
        else
        if Parser.CurName = 'hash'        then result := processaHash
        else
            writeln ('xml bichado: ', Parser.CurName);

    if Parser.Scan then
        writeln ('xml com lixo aps o ltimo elemento: ', Parser.CurName);

    Parser.Free;
end;

var
    nomeArq: string;
    strings: TStringList;
    rootType: string;
    p: pchar;
    i: integer;

    statuses: TStatuses;
    pst: PStatus;
    pusr: PUser;
    pcat: PCategory;
    pset: PSettings;
    perrs: TErrors;
    pid_l: Pid_list;
    phsh: PHash;
    tsug: TSuggestions;
begin
    clrscr;
    sintInic(0,'');
    chdir ('xml_results');
    write ('Arquivo:' );
    nomeArq := obtemNomeArq(24);
    writeln (nomeArq);
    strings := TStringList.create;
    strings.loadFromFile (nomearq);
    p := strings.GetText;
    p := executaParsing (p, rootType);

    writeln ('Raiz: ', rootType);
    writeln ('==========================================');

    if rootType = 'statuses' then
        begin
            statuses := Tlist(p);
            for i := 0 to statuses.count-1 do
                begin
                    pst := Pstatus(statuses[i]);
                    with pst^ do
                        begin
                            writeln (created_at);
                            writeln (id);
                            writeln (text);
                            writeln (source);
                        end;
                    write ('==========================================');
                    if i < statuses.count-1 then readln;
                end;
        end
    else
    if rootType = 'status' then
        begin
            pst := PStatus(p);
            with pst^ do
                begin
                    writeln (created_at);
                    writeln (id);
                    writeln (text);
                    writeln (source);
                end;
            write ('==========================================');
        end
    else
    if rootType = 'user' then
        begin
            pusr := PUser(p);
            with pusr^ do
                begin
                    writeln (id);
                    writeln (name);
                    writeln (screen_name);
                    writeln (location);
                    writeln (description);
                    writeln (profile_image_url);
                    writeln (url);
                    writeln ('seguidores:', followers_count);
                    writeln ('amigos: ', friends_count);
                    writeln ('criado em ', created_at);
                    writeln ('favoritos: ', favourites_count);
                    writeln ('seguindo: ', following);
                    writeln ('quantos tweets: ', statuses_count);
                    writeln ('linguagem: ', lang);
                end;
        end
    else
    if rootType = 'errors' then
        begin
            perrs := Terrors(p);
            for i := 0 to perrs.Count-1 do
                writeln (perrs[i]);
        end
    else
    if rootType = 'settings' then
        begin
            pset := PSettings(p);
            with pset^ do
                begin
                    with trend__location do
                        begin
                             writeln ('trend location:');
                             writeln (centroid__latitude, ' ', centroid__longitude);
                             writeln (country);
                             writeln (country__code);
                             writeln (id);
                             writeln (location__id);
                             writeln (name);
                             writeln (parent__id);
                             writeln (place__type);
                             writeln ('end trend location');
                        end;
                    writeln (geo_enabled);
                    writeln (discoverable_by_email);
                    with sleep_time do
                        writeln ('sleep: ', start_time, ' ', end_time, ' ', enabled);
                    writeln (always_use_https);
                    with time_zone do
                        writeln ('time zone: ', name, ' ', utc_offset, ' ', tzinfo_name);
                    writeln (language);
                    writeln (show_all_inline_media);
                    writeln (protected_);
                    writeln (screen_name);
                end;
        end
    else
    if rootType = 'id_list' then
        begin
             pid_l := pid_list(p);
             for i := 0 to pid_l.Tids.count-1 do
                  writeln (pid_l.Tids[i]);
             writeln ('cursor: ', pid_l.next_cursor, '..', pid_l.previous_cursor);
        end
    else
    if rootType = 'suggestions' then
        begin
            tsug := TSuggestions(p);
            for i := 0 to tsug.count-1 do
                begin
                    pcat := tsug[i];
                    with pcat^ do
                    begin
                        writeln ('Nome: ', name);
                        writeln (slug);
                        writeln (size);
                        writeln ('================================');
                    end;
                end;
        end
    else
    if rootType = 'hash' then
        begin
            phsh := PHash(p);
            with phsh^ do
                begin
                    writeln (error);
                    writeln (request);
                end;
            write ('==========================================');
        end;

    readln;
end.

