{--------------------------------------------------------}
{                                                        }
{    Programa de acesso a redes sociais                  }
{                                                        }
{    Mdulo de folheamento de twits                      }
{                                                        }
{    Autor: Jos Antonio Borges                          }
{                                                        }
{    Em setembro/2010                                    }
{                                                        }
{--------------------------------------------------------}

unit twfolhe;

interface
uses sysutils, dvcrt, dvwin, dvform, twvars, twmsg, twoauth, twapi, twutil, twExibe;

procedure folhearTwits;
procedure folhearDiretas;
procedure folheamento;
procedure buscarConteudos;

implementation

uses Classes;

procedure folhear (cmd: string; opcao: char);
var resp: string;
    separador: char;
    pagina: integer;
    continua: boolean;
begin
    pagina := 1;
    if pos ('?', cmd) <> 0 then separador := '&'
                           else separador := '?';
    if getFromTwitter (cmd, resp) then
        repeat
             if (opcao = 'S') or (opcao = 'B') then
                 folhearStatuses (resp, opcao, continua)
             else
                 folhearDirectMessages (resp, continua);

             if continua then
                 begin
                     inc(pagina);
                     continua := getFromTwitter (cmd+separador+
                                                'page='+intToStr(pagina), resp);
                 end;
        until not continua;
end;

procedure folhearTwits;
begin
    folhear ('/1.1/statuses/home_timeline.json', 'S');
end;

procedure folhearTwitsGlobais;
begin
    folhear ('/1.1/statuses/sample.json', 'S');
end;

procedure folhearMencoes;
begin
    folhear ('/1.1/statuses/mentions_timeline.json', 'S');
end;

procedure folhearEnviadasPorMim;
begin
    folhear ('/1.1/statuses/user_timeline.json', 'S');
end;

procedure folhearEnviadasPorAlguem;
var apelido: string;
begin
    mensagem ('TWAPEBUS', 0);     {'Informe o apelido buscado: '}
    sintReadln (apelido);
    if apelido = '' then
        begin
            mensagem ('TWDESIST', 1);   {'Desistiu...'}
            exit;
        end;
    if apelido[1] = '@' then delete (apelido, 1, 1);
    folhear ('/1.1/statuses/user_timeline.json?screen_name='+urlEncode2(apelido), 'S');
end;

procedure buscarConteudos;
var conteudo: string;
begin
    mensagem ('TWCNTBUS', 0);     {'Informe o contedo buscado: '}
    sintReadln (conteudo);
    if conteudo = '' then
        begin
            mensagem ('TWDESIST', 1);   {'Desistiu...'}
            exit;
        end;
    folhear ('/1.1/search/tweets.json?q='+urlEncode2(conteudo), 'B')
end;

procedure folhearDiretas;
begin
    folhear ('/1.1/direct_messages/events/list.json', 'D');
end;

procedure folhearDiretasEnviadas;
begin
    folhear ('/1.1/direct_messages/sent.json', 'D');
end;

procedure folhearPorComando;  { para testes do protocolo }
var cmd: string;
    resp: string;
begin
    mensagem ('TWCMD', 0); {'Comando: '}
    sintReadln (cmd);
    writeln;
    getFromTwitter (cmd, resp);
    dump (resp);
    sintWriteln ('Veja resposta em log.txt');
end;


procedure ajudaFolheamento;
begin
    limpaBaixo;
    writeln;
    mensagem ('TWOPSAO', 2);  {'As opes so'}
    mensagem ('TWFL_T', 1);   {'T: folhear Twits'}
    mensagem ('TWFL_M', 1);   {'M: folhear Menes'}
    mensagem ('TWFL_E', 1);   {'E: folhear Enviadas por mim'}
    mensagem ('TWFL_A', 1);   {'A: folhear enviadas por Algum'}
    mensagem ('TWFL_D', 1);   {'D: folhear Diretas'}
    mensagem ('TWFL_V', 1);   {'V: folhear diretas enViadas por mim'}
end;

function selSetasOpcao: char;
var n: integer;
const
    opmenu: string = 'TMEADV' + #$1b;
begin
    popupMenuCria(wherex, wherey, 50, 20, RED);
    popupMenuAdiciona ('TWFL_T', 'T: folhear Twits');
    popupMenuAdiciona ('TWFL_M', 'M: folhear Menes');
    popupMenuAdiciona ('TWFL_E', 'E: folhear Enviadas por mim');
    popupMenuAdiciona ('TWFL_A', 'A: folhear enviadas por Algum');
    popupMenuAdiciona ('TWFL_D', 'D: folhear Diretas');
    popupMenuAdiciona ('TWFL_V', 'V: folhear diretas enViadas por mim');
    popupMenuAdiciona ('TWOP_ESC', 'ESC - terminar');

    n := popupMenuSeleciona;
    if (n < 1) then
        result := #$0
    else
        result := opmenu[n];
end;

procedure folheamento;
var c, c2: char;
label deNovo;
begin
deNovo:
    gotoxy (1, 7);
    textBackground (MAGENTA);
    mensagem ('TWTIPFOL', 0);    {'Qual o tipo de folheamento? '}
    textBackground (BLACK);
    clreol;
    sintLeTecla (c, c2);
    writeln;

    if c = #$0 then
        case c2 of
                F1:  begin
                        ajudaFolheamento;
                        c := ' ';
                     end;
                CIMA, BAIX: c := selSetasOpcao;
        end;

    if c in ['a'..'z'] then
        c := upcase(c);

    case c of
        ESC:   exit;
        'T': folhearTwits;
        'G': folhearTwitsGlobais;
        'M': folhearMencoes;
        'E': folhearEnviadasPorMim;
        'A': folhearEnviadasPorAlguem;
        'D': folhearDiretas;
        'V': folhearDiretasEnviadas;
        '/': folhearPorComando;   // para testes apenas
    else
        mensagem ('TWOPINV', 1);   {'Opo invlida, F1 ajuda.'}
        goto deNovo;
    end;
end;

end.

