{--------------------------------------------------------}
{                                                        }
{    Programa de acesso a redes sociais                  }
{                                                        }
{    Mdulo de processamento XML (Obsoleto)              }
{                                                        }
{    Autor: Jos Antonio Borges                          }
{                                                        }
{    Em setembro/2010                                    }
{                                                        }
{--------------------------------------------------------}

unit twxml;

interface
uses
  dvcrt, dvwin, dvarq, SysUtils, classes, LibXmlParser;

type
    PStatus = ^TStatus;
    PUser = ^TUser;
    PDirectMessage = ^TDirectMessage;
    PCategory = ^TCategory;
    PSettings = ^TSettings;
    PId_list = ^TId_list;
    PHash = ^THash;
    PError = ^THash;
    PRelationship = ^TRelationShip;

    TStatuses = TList;
    TUsers = TList;
    TDirectMessages = Tlist;
    TSuggestions = TList;
    TErrors = TStringList;
    TNil__classes = TList;
    PSender = PUser;
    PRecipient = PUser;

    TStatus = record
        created_at: string;
        id: string;
        text: string;
        source: string;
        truncated: string;
        favorited: string;
        in_reply_to_status_id: string;
        in_reply_to_user_id: string;
        in_reply_to_screen_name: string;
        retweet_count: string;
        retweeted: string;
        user: PUser;
        geo: string;
        coordinates: string;
        //place: string;
        contributors: string;
        retweeted_status: Pstatus;
        possibly_sensitive: string;
    end;

    TUser = record
        id: string;
        name: string;
        screen_name: string;
        location: string;
        description: string;
        profile_image_url: string;
        profile_image_url_https: string;
        url: string;
        protected_: string;
        followers_count: string;
        profile_background_color: string;
        profile_text_color: string;
        profile_link_color: string;
        profile_sidebar_fill_color: string;
        profile_sidebar_border_color: string;
        friends_count: string;
        created_at: string;
        favourites_count: string;
        utc_offset: string;
        time_zone: string;
        profile_background_image_url: string;
        profile_background_image_url_https: string;
        profile_background_tile: string;
        profile_use_background_image: string;
        notifications: string;
        geo_enabled: string;
        verified: string;
        following: string;
        statuses_count: string;
        lang: string;
        contributors_enabled: string;
        follow_request_sent: string;
        listed_count: string;
        show_all_inline_media: string;
        default_profile: string;
        default_profile_image: string;
        is_translator: string;
        status: PStatus;
        retweeted_status: PStatus;
    end;

    TDirectMessage = record
        created_at: string;
        id: string;
        text: string;
        sender_id: string;
        recipient_id: string;
        sender_screen_name: string;
        recipient_screen_name: string;
        sender: PSender;
        recipient: PRecipient;
    end;

    TCategory = record   // suggestions
        name: string;
        slug: string;
        size: int64;
    end;

    TSettings = record
        trend__location: record
            centroid__latitude: string;
            centroid__longitude: string;
            country: string;
            country__code: string;
            id: string;
            location__id: integer;
            name: string;
            parent__id: string;
            place__type: integer;
          end;
        geo_enabled: string;
        discoverable_by_email: string;
        sleep_time: record
            start_time: string;
            end_time: string;
            enabled: string;
        end;
        always_use_https: string;
        time_zone: record
            name: string;
            utc_offset: string;
            tzinfo_name: string;
        end;
        language: string;
        show_all_inline_media: string;
        protected_: string;
        screen_name: string;
    end;

    TId_list = record
        Tids: TStringList;
        next_cursor: int64;
        previous_cursor: int64;
    end;

    THash = record
        error: string;
        request: string;
    end;

    TRelationship = record
        following: boolean;
        followed_by: boolean;
    end;

var
    Parser: TXmlParser;

function executaParsing (pxml: pchar; var rootType: string): pointer;
function dumbParsing (pxml: pchar; var rootType: string): TStringList;

implementation

function processaStatus: PStatus; forward;

function processaUser (initialTag: string): PUser;   // processa user, sender, recipient
var pusu: PUser;

    procedure atribui;
    var t: string;
        c: string;
    begin
        t := Parser.Curname;
        if t = 'status' then
            pusu^.status := processaStatus
        else
        if t = 'retweeted_status' then
            pusu^.retweeted_status := processaStatus
        else

        with pusu^ do
                begin
                    Parser.Scan;
                    c := Parser.CurContent;
                    if      t = 'id'                                 then id := c
                    else if t = 'name'                               then name := c
                    else if t = 'screen_name'                        then screen_name := c
                    else if t = 'location'                           then location := c
                    else if t = 'description'                        then description := c
                    else if t = 'profile_image_url'                  then profile_image_url := c
                    else if t = 'profile_image_url_https'            then profile_image_url_https := c
                    else if t = 'url'                                then url := c
                    else if t = 'protected'                          then protected_ := c
                    else if t = 'followers_count'                    then followers_count := c
                    else if t = 'profile_background_color'           then profile_background_color := c
                    else if t = 'profile_text_color'                 then profile_text_color := c
                    else if t = 'profile_link_color'                 then profile_link_color := c
                    else if t = 'profile_sidebar_fill_color'         then profile_sidebar_fill_color := c
                    else if t = 'profile_sidebar_border_color'       then profile_sidebar_border_color := c
                    else if t = 'friends_count'                      then friends_count := c
                    else if t = 'created_at'                         then created_at := c
                    else if t = 'favourites_count'                   then favourites_count := c
                    else if t = 'utc_offset'                         then utc_offset := c
                    else if t = 'time_zone'                          then time_zone := c
                    else if t = 'profile_background_image_url'       then profile_background_image_url := c
                    else if t = 'profile_background_image_url_https' then profile_background_image_url_https := c
                    else if t = 'profile_background_tile'            then profile_background_tile := c
                    else if t = 'profile_use_background_image'       then profile_use_background_image := c
                    else if t = 'notifications'                      then notifications := c
                    else if t = 'geo_enabled'                        then geo_enabled := c
                    else if t = 'verified'                           then verified := c
                    else if t = 'following'                          then following := c
                    else if t = 'statuses_count'                     then statuses_count := c
                    else if t = 'lang'                               then lang := c
                    else if t = 'contributors_enabled'               then contributors_enabled := c
                    else if t = 'follow_request_sent'                then follow_request_sent := c
                    else if t = 'listed_count'                       then listed_count := c
                    else if t = 'show_all_inline_media'              then show_all_inline_media := c
                    else if t = 'default_profile'                    then default_profile := c
                    else if t = 'default_profile_image'              then default_profile_image := c
                    else if t = 'is_translator'                      then is_translator := c
                    else
                    //    writeln ('Encontrei uma coisa estranha: ', t)
                    ;
                end;
    end;

begin
    new (pusu);
    result := NIL;
    pusu^.status := NIL;
    pusu^.retweeted_status := NIL;
    while Parser.Scan DO
        begin
            if (Parser.CurPartType = ptStartTag) then
                 atribui
            else
            if Parser.CurPartType = ptEndTag then
                begin
                    if Parser.CurName = initialTag then
                        begin
                            result := pusu;
                            exit;
                        end;
                end
            else
                if (Parser.CurPartType <> ptEmptyTag) then
                    {writeln ('xml bichado: ', Parser.CurName)};
        end;
end;

function processaStatus: PStatus;
var pst: PStatus;

    procedure atribui;
    var t: string;
        c: string;
    begin
        t := Parser.Curname;
        if t = 'user' then
            pst^.user := processaUser('user')
        else
        if t = 'retweeted_status' then
            pst^.retweeted_status := processaStatus
        else
        if t = 'place' then
            begin
                while Parser.Scan and
                    (not((Parser.CurPartType = ptEndTag) and (Parser.CurName = 'place'))) do;
            end
        else
            with pst^ do
                begin
                    Parser.Scan;
                    c := Parser.CurContent;

                    if      t = 'created_at'              then created_at := c
                    else if t = 'id'                      then id := c
                    else if t = 'text'                    then text := c
                    else if t = 'source'                  then source := c
                    else if t = 'truncated'               then truncated := c
                    else if t = 'favorited'               then favorited := c
                    else if t = 'in_reply_to_status_id'   then in_reply_to_status_id := c
                    else if t = 'in_reply_to_user_id'     then in_reply_to_user_id := c
                    else if t = 'in_reply_to_screen_name' then in_reply_to_screen_name := c
                    else if t = 'retweet_count'           then retweet_count := c
                    else if t = 'retweeted'               then retweeted := c
                    else if t = 'geo'                     then geo := c
                    else if t = 'coordinates'             then coordinates := c
                    else if t = 'contributors'            then contributors := c
                    else if t = 'possibly_sensitive'      then possibly_sensitive := c
                    else
                    //    writeln ('Encontrei uma coisa estranha: ', t)
                    ;
                end;
    end;

begin
    new (pst);
    result := NIL;
    pst^.user := NIL;
    pst^.retweeted_status := NIL;

    while Parser.Scan DO
        begin
            if (Parser.CurPartType = ptStartTag) then
                 atribui
            else
            if Parser.CurPartType = ptEndTag then
                begin
                    if (Parser.CurName = 'status') or (Parser.CurName = 'retweeted_status') then
                        begin
                            result := pst;
                            exit;
                        end;
                end
            else
                if (Parser.CurPartType <> ptEmptyTag) then
                    {writeln ('xml bichado: ', Parser.CurName)};
        end;
end;

function processaStatuses: TStatuses;
var stats: TStatuses;
begin
    stats := TStatuses.Create;
    result := NIL;
    while Parser.Scan DO
        begin
            if Parser.CurPartType = ptStartTag then
                 begin
                    if Parser.CurName = 'status' then
                         stats.Add(processaStatus);
                 end
            else
            if (Parser.CurPartType = ptEndTag) and (Parser.CurName = 'statuses') then
                begin
                    result := stats;
                    exit;
                end
            else
                if (Parser.CurPartType <> ptEmptyTag) then
                    {writeln ('xml bichado: ', Parser.CurName)};
        end;
end;

function processaUsers: TUsers;
var usrs: TUsers;
begin
    usrs := TUsers.Create;
    result := NIL;
    while Parser.Scan DO
        begin
            if Parser.CurPartType = ptStartTag then
                begin
                    if Parser.CurName = 'user' then
                         usrs.Add(processaUser('user'));
                 end
            else
            if (Parser.CurPartType = ptEndTag) and (Parser.CurName = 'users') then
                begin
                    result := usrs;
                    exit;
                end
            else
                if (Parser.CurPartType <> ptEmptyTag) then
                    {writeln ('xml bichado: ', Parser.CurName)};
        end;
end;

function processaDirectMessage: PDirectMessage;
var pdmsg: PDirectMessage;

    procedure atribui;
    var t: string;
        c: string;
    begin
        t := Parser.Curname;
        if t = 'sender' then
            begin
                pdmsg^.sender := processaUser('sender');
            end
        else
        if t = 'recipient' then
            begin
                pdmsg^.recipient := processaUser('recipient');
            end
        else
            with pdmsg^ do
                begin
                    Parser.Scan;
                    c := Parser.CurContent;

                    if      t = 'created_at'              then created_at := c
                    else if t = 'id'                      then id := c
                    else if t = 'text'                    then text := c
                    else if t = 'sender_id'               then sender_id := c
                    else if t = 'recipient_id'            then recipient_id := c
                    else if t = 'sender_screen_name'      then sender_screen_name := c
                    else if t = 'recipient_screen_name'   then recipient_screen_name := c
                    else
                    //    writeln ('Encontrei uma coisa estranha: ', t)
                    ;
                end;
    end;

begin
    new (pdmsg);
    result := NIL;
    pdmsg^.sender := NIL;
    pdmsg^.recipient := NIL;
    while Parser.Scan DO
        begin
            if (Parser.CurPartType = ptStartTag) then
                 atribui
            else
            if Parser.CurPartType = ptEndTag then
                begin
                    if (Parser.CurName = 'direct_message') then
                        begin
                            result := pdmsg;
                            exit;
                        end;
                end
            else
                if (Parser.CurPartType <> ptEmptyTag) then
                    {writeln ('xml bichado: ', Parser.CurName)};
        end;
end;

function processaDirectMessages: TDirectMessages;
var dmsgs: TDirectMessages;
begin
    dmsgs := TDirectMessages.Create;
    result := NIL;
    while Parser.Scan DO
        begin
            if Parser.CurPartType = ptStartTag then
                 begin
                    if Parser.CurName = 'direct_message' then
                         dmsgs.Add(processaDirectMessage);
                 end
            else
            if (Parser.CurPartType = ptEndTag) and (Parser.CurName = 'direct-messages') then
                begin
                    result := dmsgs;
                    exit;
                end
            else
                if (Parser.CurPartType <> ptEmptyTag) then
                    {writeln ('xml bichado: ', Parser.CurName)};
        end;
end;

function processaSuggestions: TSuggestions;
var
    psug: TSuggestions;
    pcat: PCategory;

    procedure atribui;
    var t: string;
        c: string;
    begin
        t := Parser.Curname;
        Parser.Scan;
        c := Parser.CurContent;
        if      t = 'name' then pcat^.name := c
        else if t = 'slug' then pcat^.slug := c
        else if t = 'size' then pcat^.size := strToInt64 (c)
        else
        //    writeln ('Encontrei uma coisa estranha: ', t)
        ;
    end;

begin
    psug := TSuggestions.Create;
    result := psug;
    pcat := NIL;
    while Parser.Scan DO
        begin
            if Parser.CurPartType = ptStartTag then
                 if Parser.CurName = 'category' then
                     begin
                         new (pcat);
                         pcat^.name := '';
                         pcat^.slug := '';
                         pcat^.size := 0;
                         psug.add (pcat);
                     end
                 else
                     atribui
            else
            if (Parser.CurPartType = ptEndTag) then
                begin
                    if (Parser.CurName = 'suggestions') then
                        begin
                            result := psug;
                            exit;
                        end;
                end
            else
                if (Parser.CurPartType <> ptEmptyTag) then
                    {writeln ('xml bichado: ', Parser.CurName)};
        end;
end;

function processaSettings: Psettings;
var
    pset: PSettings;

    procedure atribui;
    var t: string;
        c: string;
    begin
        t := Parser.Curname;
        if (t = 'trend-location') or (t = 'sleep_time') or (t = 'time_zone') then
           begin end
        else
        with pset^ do
            begin
                Parser.Scan;
                c := Parser.CurContent;

                if      t = 'centroid-latitude'     then trend__location.centroid__latitude := c
                else if t = 'centroid-longitude'    then trend__location.centroid__longitude := c
                else if t = 'country'               then trend__location.country := c
                else if t = 'country-code'          then trend__location.country__code := c
                else if t = 'id'                    then trend__location.id := c
                else if t = 'location-id'           then trend__location.location__id := strToInt(c)
                else if t = 'name'                  then trend__location.name := c
                else if t = 'parent-id'             then trend__location.parent__id := c
                else if t = 'place-type'            then trend__location.place__type := strToInt(c)
                else if t = 'geo_enabled'           then geo_enabled := c
                else if t = 'discoverable_by_email' then discoverable_by_email := c
                else if t = 'start_time'            then sleep_time.start_time := c
                else if t = 'end_time'              then sleep_time.end_time := c
                else if t = 'enabled'               then sleep_time.enabled := c
                else if t = 'always_use_https'      then always_use_https := c
                else if t = 'name'                  then time_zone.name := c
                else if t = 'utc_offset'            then time_zone.utc_offset := c
                else if t = 'tzinfo_name'           then time_zone.tzinfo_name := c
                else if t = 'language'              then language := c
                else if t = 'show_all_inline_media' then show_all_inline_media := c
                else if t = 'protected'             then protected_ := c
                else if t = 'screen_name'           then screen_name := c
                else
                //    writeln ('Encontrei uma coisa estranha: ', t)
                ;
            end;
    end;

begin
    new (pset);
    result := NIL;
    while Parser.Scan DO
        begin
            if (Parser.CurPartType = ptStartTag) then
                 atribui
            else
            if (Parser.CurPartType = ptEndTag) and (Parser.CurName = 'settings') then
                begin
                    result := pset;
                    exit;
                end
            else
                if (Parser.CurPartType <> ptEmptyTag) then
                    {writeln ('xml bichado: ', Parser.CurName)};
        end;
end;

function processaErrors: TErrors;
var erros: TStringList;
    nerro: string;
begin
    erros := TStringList.Create;
    result := NIL;
    while Parser.Scan DO
        begin
            if (Parser.CurPartType = ptStartTag) and (Parser.CurName = 'error') then
                 begin
                     //...................melhorar este cdigo ........................
                     nerro := Parser.CurAttr.Value(0);
                     parser.scan;
                     erros.Add(nerro + ' ' + Parser.CurContent);
                 end
            else
            if Parser.CurPartType = ptEndTag then
                begin
                    if Parser.CurName = 'errors' then
                        begin
                            result := erros;
                            exit;
                        end
                end
            else
                if (Parser.CurPartType <> ptEmptyTag) then
                    {writeln ('xml bichado: ', Parser.CurName)};
        end;
end;

function processaId_List: PId_List;
var
    lista: PId_list;
    t: string;
    c: string;

begin
    lista := new(PId_list);
    lista.Tids := TstringList.create;

    result := lista;
    while Parser.Scan DO
        begin
            if (Parser.CurPartType = ptStartTag) then
                begin
                    t := Parser.CurName;
                    if t = 'ids' then
                    else
                        begin
                            parser.Scan;
                            c := parser.CurContent;

                            if t = 'id' then lista.Tids.add (c)
                            else if t = 'next_cursor'     then lista.next_cursor := StrToInt64(c)
                            else if t = 'previous_cursor' then lista.previous_cursor := StrToInt64(c)
                            else
                            //    writeln ('Encontrei uma coisa estranha: ', t)
                            ;
                        end;
                end
            else
            if Parser.CurPartType = ptEndTag then
                begin
                    if Parser.CurName = 'id_list' then  exit;
                end
            else
            if (Parser.CurPartType <> ptEmptyTag) then
                {writeln ('xml bichado: ', Parser.CurName)};
        end;

end;

function processaHash: PHash;
var phsh: PHash;

    procedure atribui;
    var t: string;
        c: string;
    begin
        t := Parser.Curname;
        with phsh^ do
                begin
                    Parser.Scan;
                    c := Parser.CurContent;
                    if      t = 'error'   then error := c
                    else if t = 'request' then request := c
                    else
                    //    writeln ('Encontrei uma coisa estranha: ', t)
                    ;
                end;
    end;

begin
    new (phsh);
    result := NIL;
    while Parser.Scan DO
        begin
            if (Parser.CurPartType = ptStartTag) then
                 atribui
            else
            if Parser.CurPartType = ptEndTag then
                begin
                    if (Parser.CurName = 'hash') then
                        begin
                            result := phsh;
                            exit;
                        end;
                end
            else
                if (Parser.CurPartType <> ptEmptyTag) then
                    {writeln ('xml bichado: ', Parser.CurName)};
        end;
end;

function processaRelationship: Prelationship;
var prel: PRelationship;
    emTarget: boolean;

begin
    new (prel);
    emTarget := false;

    result := NIL;
    while Parser.Scan DO
        begin
            if (Parser.CurPartType = ptStartTag) then
                 begin
                     if Parser.CurName = 'target' then
                         emTarget := true
                     else
                         if emTarget and (parser.CurName = 'following') then
                             begin
                                 Parser.Scan;
                                 prel.following := parser.CurContent = 'true';
                             end
                         else
                         if emTarget and (parser.CurName = 'followed_by') then
                             begin
                                 Parser.Scan;
                                 prel.followed_by := parser.CurContent = 'true';
                             end
                 end
            else
            if Parser.CurPartType = ptEndTag then
                 if Parser.CurName = 'relationship' then result := prel;
        end;
end;

function processaNilClasses: TNil__classes;
begin
    result := NIL;
    while Parser.Scan DO
        if (Parser.CurPartType = ptEndTag) and (Parser.CurName = 'nil-classes') then
            exit;
end;

function executaParsing (pxml: pchar; var rootType: string): pointer;
begin
    Parser := TXmlParser.Create;
    Parser.Normalize := TRUE;
    Parser.SetBuffer(pxml);
    Parser.StartScan;

    result := NIL;
    Parser.Scan;
    Parser.Scan;

    rootType := Parser.CurName;

    if Parser.CurPartType = ptStartTag then
        if Parser.CurName = 'statuses'    then result := processaStatuses
        else
        if Parser.CurName = 'status'      then result := processaStatus
        else
        if Parser.CurName = 'users'       then result := processaUsers
        else
        if Parser.CurName = 'user'        then result := processaUser('user')
        else
        if Parser.CurName = 'direct-messages' then result := processaDirectMessages
        else
        if Parser.CurName = 'direct-message' then result := processaDirectMessage
        else
        if Parser.CurName = 'settings'    then result := processaSettings
        else
        if Parser.CurName = 'errors'      then result := processaErrors
        else
        if Parser.CurName = 'id_list'     then result := processaId_List
        else
        if Parser.CurName = 'suggestions' then result := processaSuggestions
        else
        if Parser.CurName = 'hash'        then result := processaHash
        else
        if Parser.CurName = 'relationship' then result := processaRelationship
        else
            result := pxml;   // desconhecido

    if (result <> pxml) and (Parser.Scan) then
        writeln ('xml com lixo aps o ltimo elemento: ', Parser.CurName);

    Parser.Free;
end;

var sl: TStringList;

function dumbParsing (pxml: pchar; var rootType: string): TStringList;
var
    s: string;
begin
    sl := TStringList.create;
    // quem chamar tem que liberar a stringList

    Parser := TXmlParser.Create;
    Parser.Normalize := TRUE;
    Parser.SetBuffer(pxml);
    Parser.StartScan;

    Parser.Scan;
    Parser.Scan;

    rootType := Parser.CurName;
    s := '';
    while Parser.Scan DO
        begin
            if Parser.CurPartType = ptStartTag then
                 s := parser.CurName
            else
            if Parser.CurPartType = ptContent then
                 sl.Add(s + ': ' + Parser.CurContent);
        end;
    Parser.Free;
    result := sl;
end;


end.

